## 1.3 摩尔定律、多核处理器和并发编程

### 1.3.1 摩尔定律

Intel公司联合创始人摩尔曾经预言，计算机的处理能力大约每两年就会以低廉的成本翻一番。这就是著名的摩尔定律。摩尔定律在过去的几十年间，被事实证明是完全成立的，尤其对以下场景而言：

- 存储程序和数据的主存储器容量
- 存储程序和数据的辅助存储器容量
- 执行程序指令的处理器速度

不过近年来，NVIDIA和ARM的核心管理层表示，摩尔定律或许已经不再适用。计算机处理能力虽然还会加强，但更多依赖于新的处理器设计，尤其是多核处理器。

### 1.3.2 多核处理器

目前大多数计算机都具有多核处理器，即在一块集成电路芯片上经济地实现多个处理器。例如：

- 双核处理器相当于两个CPU
- 四核处理器相当于四个CPU
- 八核处理器相当于八个CPU
- ······

多核系统可以令不同的处理器并行处理任务的不同部分，从而使任务得以更快完成。

为了充分发挥多核架构的优势，需要编写多线程应用程序。这样的程序可以将一个任务划分成多个独立执行的线程。只要处理器核心的数量足够多，这些线程就可以同时被执行，极大地缩短整个任务所消耗的时间。

C++对多线程编程的支持自C++11开始，之后的每个C++标准都会通过增加一些更高级的特性，来降低多线程编程的难度和复杂度。C++20引入的协程，允许人们以简单的，类似顺序编码的风格实现并发编程。