## 2.2 第一个C++程序

这是一个显示单行文本的简单程序。

...\Ch02\Welcome\Welcome.cpp：

```c++
// Welcome.cpp
//
// 打印文本
//
#include <iostream> // 使程序可以在屏幕上输出数据

// 主函数是程序执行的起点
int main() {
    std::cout << "欢迎使用C++！\n"; // 显示消息

    return 0; // 成功退出
} // 主函数结束
```

编译运行：

```
欢迎使用C++！
```

### 2.2.1 注释

程序代码的前四行为以“//”引导的单行注释。单行注释以行末截止。另一种注释是用一对“/\*”和“*/”括起来的单或多行注释。程序代码的前四行也可以写成下面这样：

```c++
/* Welcome.cpp */

/* 打印文本 */

```

或者写成这样：

```c++
/* Welcome.cpp

   打印文本
*/
```

无论哪种注释，被注释的内容都是不参加编译的。

### 2.2.2 预处理指令

程序代码的第5行是一条预处理指令。预处理指令由预处理器在编译器编译代码之前执行。这条预处理指令称为文件包含预处理指令，其作用是指示预处理器将输入输出流头文件\<iostream\>的内容，插入到该条指令所在的位置。任何使用了C++输入输出功能的程序，都需要有这条预处理指令。

### 2.2.3 空行和空白

程序代码的第6行是一个空行。类似空格、制表、空行这样的字符统称为空白字符，仅用于改善代码的可读性，编译时会被直接忽略。

### 2.2.4 主函数

程序代码的第8到12行为主函数。C++程序通常由一个或多个函数和类组成。每个程序必须有且只能有一个名为“main”的函数，谓之主函数。主函数是程序执行的起点，亦称入口点。关键字“int”表示主函数的返回值为整型。成功返回0，失败返回-1。第8行末尾处的左花括号和第12行开始处的右花括号，分别表示主函数函数体的开始和结束，其间的部分为主函数的函数体，即该函数需要执行的指令序列。

### 2.2.5 输出语句

程序代码的第9行是一条输出语句。所输出的内容由一对双引号引起来的字符串字面值表示。字符串中的空白字符不会被编译器忽略。整个第9行，截止到分号，是一个完整的语句。大多数C++语句必须以分号结束。预处理指令不是C++语句，因此不带分号。C++语言的输入和输出，需要借助所谓“流”来进行。“std::cout”即表示标准输出流，即屏幕。

### 2.2.6 缩进

不同语法层级的语句带有不同的缩进量。这虽然不是强制的，但确实能令程序代码更容易阅读。每层比上一层缩进一个制表符或者四个空格，是比较常见的做法。无论采用什么惯例，保持一致就好。

### 2.2.7 名字空间

所有来自标准库的名字，如cin、cout、cerr等，都位于std名字空间内。引用这些名字时，需要加上形如“std::”的名字空间前缀，除非使用using声明或using指令。

### 2.2.8 流插入操作符

输出语句中的“<<”称为流插入操作符，表示将其右边的值，插入到其左边的流对象cout中。注意箭头的方向就是数据的流动方向。

### 2.2.9 转义字符

输出字符串中的“\n”并没有被输出为“\”和“n”，而是在字符串的末尾另起了一个新行。这就叫做转义字符，即字符“n”不再表示字符“n”的本义，而是连同其前面的“\”一起被转义为换行。常见的转义字符如下表所示：

转义字符|说明
:-:|:-
`\n`|换行
`\t`|水平制表
`\r`|回车
`\a`|响铃
`\'`|单引号
`\"`|双引号
`\\`|反斜杠

### 2.2.10 return语句

程序代码的第11行是一条return语句，表示函数返回。main函数的返回有特殊的意义，即程序退出运行。返回0表示成功退出。若程序在执行到main函数的结束花括号之前，没有遇到return语句，则会默认返回0，故该语句也可省略不写，默认成功退出。