## 3.11 基本类型不可移植

C++语言的基本数据类型及其取值范围可以参考：

- https://zh.cppreference.com/w/cpp/language/types

C++语言的整数类型包括：short、int、long和long long。C++标准要求：

- short类型的字节数不得大于int类型的字节数
- int类型的字节数不得少于2且不得大于long类型的字节数
- long类型的字节数不得少于4且不得大于long long类型的字节数
- long long类型的字节数不得少于8

这种“软弱”的要求带来了可移植性的挑战，但允许编译器的实现者，通过将基本类型的大小与机器的硬件相匹配，来优化性能。一个int类型的变量：

- 在第一台机器上可能使用2个字节
- 在第二台机器上可能使用4个字节
- 在第三台机器上可能使用8个字节

因此，使用基本整数类型的代码，并非总能保证跨平台可移植。

在\<cstdint\>头文件中定义了一组有关整数的类型别名，可以保证在不同平台上都有一致的大小，详见：

- https://zh.cppreference.com/w/cpp/types/integer