## 4.2 计数器控制循环的本质

利用while循环语句，实现一个计数器控制下的循环过程，其中包含如下要素：

- 一个充当循环计数器的控制变量
- 为控制变量指定初始值
- 在循环体中对计数器做累加
- 根据计数器的值决定循环是否还要继续

下面的程序用于显示0到9这十个阿拉伯数字。

...\Ch04\CounterWhile\CounterWhile.cpp：

```c++
// CounterWhile.cpp
//
// 计数器控制下的while循环语句
//
#include <iostream>
using namespace std;

int main() {
    int counter{ 0 }; // 声明并初始化用于控制循环次数的计数器变量

    while (counter < 10) { // 继续循环的条件
        cout << counter << " ";
        ++counter; // 对计数器的值做累加
    }

    cout << endl;
}
```

编译运行：

```
0 1 2 3 4 5 6 7 8 9
```

程序代码的第9、11和13行包含了实现计数器控制的循环的所有要素：

- 第9行声明了用于控制循环次数的计数器变量counter，并将其值初始化为0
- 在可执行语句中的变量声明，称为变量的定义
- 第11行通过对条件counter是否小于10的判断，决定循环是否还要继续
- 第13行对计数器的值做累加，当其被加到10时，因其不满足循环继续的条件，退出循环

由于浮点数在计算机中总是以近似值存储的，用浮点型变量作为控制循环的计数器，可能会因其不精确的计数值，导致循环无法正常终止。鉴于此，总是用整型变量作为控制循环的计数器。