## 4.4 for循环语句示例

下面给出几个for循环语句头的示例，旨在说明控制变量的各种用法：

1. 控制变量从1变到100，每次递增1，循环体中的代码执行100次
   ```c++
   for (int i{ 1 }; i <= 100; ++i) { ... }
   ```
2. 控制变量从100变到1，每次递减1，循环体中的代码执行100次
   ```c++
   for (int i{ 100 }; i >= 1; --i) { ... }
   ```
3. 控制变量从7变到77，每次递增7，循环体中的代码执行11次
   ```c++
   for (int i{ 7 }; i <= 77; i += 7) { ... }
   ```
4. 控制变量从20变到2，每次递减2，循环体中的代码执行10次
   ```c++
   for (int i{ 20 }; i >= 2; i -= 2) { ... }
   ```
5. 控制变量的值依次为2、5、8、11、14、17和20，循环体中的代码执行7次
   ```c++
   for (int i{ 2 }; i <= 20; i += 3) { ... }
   ```
6. 控制变量的值依次为99、88、77、66、55、44、33、22、11和0，循环体中的代码执行10次
   ```c++
   for (int i{ 99 }; i >= 0; i -= 11) { ... }
   ```

如果每次循环控制变量的递增或递减值超过1，那么在循环继续条件中就不要使用“==”或“!=”操作符，否则可能导致无限循环。例如打印10以内的正奇数：

```c++
for (int odd { 1 }; odd != 10; odd += 2) {
	cout << odd << endl;
}
```

或者

```c++
for (int odd { 1 }; !(odd == 10); odd += 2) {
    cout << odd << endl;
}
```

在循环中，控制变量odd的值依次为1、3、5、7、9、11、······，永远不可能等于10，循环继续条件永远满足，循环永不终止。正确的写法应该是：

```c++
for (int odd { 1 }; odd < 10; odd += 2) {
    cout << odd << endl;
}
```

或者

```c++
for (int odd { 1 }; !(odd >= 10); odd += 2) {
    cout << odd << endl;
}
```

注意，for循环语句中用于判断循环是否继续的表达式用两种写法：

- `for (...; 循环继续条件; ...)`
- `for (...; !循环退出条件; ...)`

它们在本质上是等价的。