## 4.5 偶数累加

下面的程序计算从2到20的所有偶数的和。

...\Ch04\EvenSum\EvenSum.cpp：

```c++
// EvenSum.cpp
//
// 利用for循环语句计算给定区间内的所有偶数的和
//
#include <iostream>
using namespace std;

int main() {
    int sum{ 0 };

    // 从2到20的所有偶数的和
    for (int even{ 2 }; even <= 20; even += 2) {
        sum += even;
    }

    cout << "从2到20的所有偶数的和：" << sum << endl;
}
```

编译运行：

```
从2到20的所有偶数的和：110
```

程序代码使用for循环语句累加从2到20的所有偶数，并将结果保存在int型变量sum中。注意循环语句的控制变量even，从2开始每次递增2，以保证每次执行循环体中的代码时，其值都是偶数。保存累加结果的变量sum必须被初始化为0，以确保最终的结果中不含有除2到20间的偶数以外值。

for循环语句头的初始化语句和递增语句，可以是由多个表达式组成的列表，表达式之间以逗号分隔。虽然不鼓励这样做，但确实可以通过逗号操作符，将循环体中的代码合并到for循环语句头中。例如：

```c++
for (int even{ 2 }; even <= 20; sum += even, even += 2) {
}
```

采用这种写法时的循环体为空语句，用一对空花括号或者一个单独的分号表示：

```c++
for (int even{ 2 }; even <= 20; sum += even, even += 2);
```

注意无论采用哪种写法，表示空语句的空花括号或者分号都不能省略，否则下面的输出语句：

```c++
cout << "从2到20的所有偶数的和：" << sum << endl;
```

将被当作循环体中代码，参与到for循环语句的执行过程中。这显然是一个逻辑错误。例如下面的代码：

```c++
for (int even{ 2 }; even <= 20; sum += even, even += 2)

cout << "从2到20的所有偶数的和：" << sum << endl;
```

等价于：

```c++
for (int even{ 2 }; even <= 20; sum += even, even += 2)
    cout << "从2到20的所有偶数的和：" << sum << endl;
```

等价于：

```c++
for (int even{ 2 }; even <= 20; sum += even, even += 2) {
    cout << "从2到20的所有偶数的和：" << sum << endl;
}
```

得到错误的运行结果：

```
从2到20的所有偶数的和：0
从2到20的所有偶数的和：2
从2到20的所有偶数的和：6
从2到20的所有偶数的和：12
从2到20的所有偶数的和：20
从2到20的所有偶数的和：30
从2到20的所有偶数的和：42
从2到20的所有偶数的和：56
从2到20的所有偶数的和：72
从2到20的所有偶数的和：90
```

逗号“,”在C++语言中是一个操作符，其优先级在所有操作符中最低。由逗号操作符组成的表达式称为逗号表达式。在逗号表达式中，被逗号分隔的一系列子表达式，会按照从左到右的顺序依次被求值。整个逗号表达式的数据类型和值，由其最右边的子表达式决定。需要多个初始化表达式或递增表达式的for循环语句，经常使用逗号操作符。