## 5.2 程序组件

一个典型的C++程序通常由以下组件构成：

- 标准库提供的函数和类
- 各种第三方库提供的函数和类
- 自己编写的函数和类
- 同事和前辈们编写的函数和类

标准库提供的函数和类着意于解决以下问题：

- 数学
- 字符串处理
- 正则表达式
- 输入和输出
- 文件处理
- 日期和时间
- 容器及操作其内容的算法
- 内存管理
- 并发编程
- 异步编程
- ······

函数和类允许将一个程序的任务分解成独立的单元。除了调用标准库和第三方库中的现有函数外，还可以调用自己创建的函数。main函数也是自己创建的函数，此外还可以创建更多完成具体功能的函数。

为什么要以函数和类作为程序的基本组件？

- 代码复用，避免重复
- 化整为零，便于维护

为了提高程序代码的可复用性，每个函数都应该只针对单一且定义良好的任务，且函数名应恰如其分地表达这一任务。除了函数以外，类、模块等语法特性，也同样体现了一种对高度可复用性的追求。

```mermaid
graph TB
  subgraph 程序
    fun(函数)
    cls{类}
    mod((模块))
    cls---fun---mod
    cls---mod
  end
```