## 5.5 函数实参的求值顺序

在函数调用语句的实参表中，逗号仅仅是多个实参之间分隔符，并非逗号操作符。被逗号操作符连接多个操作数，严格按照从左到右的顺序依次求值。事实上，C++标准并未对函数实参的求值顺序做出规定。因此，不同的编译器，可能会按照不同的顺序，对函数调用语句中的实参序列进行求值。

当用表达式或对其它函数的调用做实参时，不同的编译器，不同求值的顺序，可能产生不同的结果。例如：

```c++
int a{ 5 };
foo(a, ++a); // 从左到右求值：foo(5,6)，从右到左求值：foo(6,6)
```

又如：

```c++
int a{ 5 };
int bar() {
    a = a + 1;
    return a;
}
foo(a, bar()); // 从左到右求值：foo(5,6)，从右到左求值：foo(6,6)
```

如果对函数实参的求值顺序，以及该顺序是否会影响函数的执行结果存有疑虑，建议先将所求之值放到单独的变量中，再以这些单独的变量作为实参，传递给被调用的函数。