## 5.7 标准库头文件

C++标准库的诸多头文件中，包含了类的定义、函数的声明，以及为这些类和函数所需要的常量等。标准库头文件告诉编译器，如何与标准库组件建立接口。

完整的C++20标准库头文件一共有96个，参见：https://zh.cppreference.com/w/cpp/header。这里列出部分常用的头文件。

### 5.7.1 C++11标准库头文件

标准库头文件|说明
:-:|:-
\<cstdio\>|C语言I/O流
\<iostream\>|C++语言I/O流
\<fstream\>|文件流
\<sstream\>|字符串流
\<iomanip\>|流控制符
\<string\>|C++语言字符串
\<cstring\>|C语言字符串
\<cctype\>|判断字符类型、字母大小写互相转换
\<cstdlib\>|数字文本相互转换、动态内存分配与释放、随机数等实用工具
\<cmath\>|数学库
\<ctime\>、\<chrono\>|日期和时间
\<random\>|随机数生成
\<memory\>|内存管理
\<typeinfo\>|运行时类型信息
\<array\>、\<vector\>、\<list\>、\<forward_list\>、\<stack\>、\<queue\>、\<deque\>、\<tuple\>、\<map\>、\<unordered_map\>、\<set\>、\<unordered_set\>、\<bitset\>|容器
\<iterator\>|容器的迭代器
\<algorithm\>|容器的算法
\<functional\>|算法
\<exception\>、\<stdexcept\>|异常
\<cassert\>|断言
\<climits\>|整数限度
\<cfloat\>|浮点数限度
\<limits\>|数值限度
\<locale\>|本地化
\<utility\>|实用工具
\<thread\>、\<mutex\>、\<shared_mutex\>、\<future\>、\<condition_variable\>|线程和线程同步

### 5.7.2 C++17标准库头文件

标准库头文件|说明
:-:|:-
\<any\>|任意可拷贝类型的单值
\<optional\>|有或没有值的对象模板
\<variant\>|类型集合
\<execution\>|标准模板库并行算法
\<filesystem\>|本地文件系统

### 5.7.3 C++20标准库头文件

标准库头文件|说明
:-:|:-
\<concepts\>|限制实例化模板的类型
\<coroutine\>|协程
\<compare\>|三路比较操作符
\<format\>|文本格式化
\<ranges\>|函数式编程
\<span\>|连续对象序列的视图
\<bit\>|位操作
\<stop_token\>、\<semaphore\>、\<latch\>、\<barrier\>|线程和线程同步