## 6.1 导读

数据结构的本质就是存放一组相关数据的集合。C++标准库将数据结构称为容器，比如：

- 大小固定的数组（array），需要包含头文件\<array\>
- 大小可变的向量（vector），需要包含头文件\<vector\>

声明、创建和初始化array，以及各种针对array的操作：

- 在array中查找特定的元素
- 对array中元素进行排序

试图访问不在array或vector边界内的数据可能导致异常，可借助异常处理捕获并处理该异常。

包括C++在内的很多现代编程语言，都提供函数式编程特性：

- 代码更加简洁，更不容易出错，更易于阅读、调试和修改
- 程序更易于并行化，充分发挥多核处理器的卓越性能
- 结合\<ranges\>库，实践函数式编程

对象自然案例：创建和操作C++标准库中的vector类模板。

两种风格的容器，array和vector。

### 6.1.1 完全限定的标准库名称

在每个程序的开始部分，写上“using namespace std;”语句，可以避免通过“std::”前缀，限定每个来自C++标准库的特性。但是，在规模较大的程序中，using指令可能导致微妙且隐蔽的缺陷。对C++标准库的大多数标识符，使用完全限定，将有助于规避这方面的问题。