## 10.1 导读

继承和运行时多态，是面向对象编程（OOP）中的重要概念。

通过继承，可以创建能吸收现有类的能力的新类，并在新类中做得更多或者更好。

在继承关系中，派生类，亦称子类，继承自基类，亦称超类。

### 10.1.1 has-a和is-a

has-a（有一个）代表一种组合关系，即一个类的对象包含另一个类的对象作为其成员。例如，汽车有一个方向盘，有一个刹车踏板，有一个发动机，有一个变速箱，等等。

is-a（是一个）代表一种继承关系，即派生类的对象也可以被视为其基类的对象。例如，汽车是一个交通工具，因此汽车具备交通工具全部的属性和行为。

### 10.1.2 运行时多态

继承、虚函数、覆盖（改写）和动态绑定，共同构成了运行时多态的基础。

运行时多态所强调的，是在常规意义上编程，而非在特定情况下编程。

借助运行时多态，可以将源自同一个基类的不同派生类对象，都视作基类对象。

运行时多态除了需要继承和虚函数以外，还必须通过基类指针或基类引用，引用派生类对象。

### 10.1.3 实现可扩展性

通过运行时多态，可以设计和实现更易于扩展的系统——只要新类是继承结构的一部分，就可以轻松地添加这些类，而使用这些类的用户代码，除非直接访问新类，只需做少量修改，甚至完全无需修改。

假设新类Car（汽车）继承自已有类Vehicle（交通工具），所有能访问Vehicle类的代码，一定也能正常操作Car类的对象。

### 10.1.4 运行时多态的底层原理

语言标准并没有规定每一种语言特性如何实现。基于虚函数表和动态绑定的运行时多态，仅是其诸多可能性实现中的一种。

### 10.1.5 非虚接口惯用法

非虚接口（Non-Virtual Interface，NVI）惯用法是除虚函数以外，另一种实现运行时多态的方法。

基类中的每个函数只起一个作用，作为可被用户代码调用执行特定任务的函数，或者作为可被派生类自定义的函数。可被派生类自定义的函数，体现了类的内部实现细节，它使系统更容易维护和进化，用户代码无需因内部实现细节的改变而改变。

### 10.1.6 接口和依赖注入

实现继承主要用于定义一组在概念上密切相关的类，它们拥有许多相同的成员变量和成员函数，将这些相同的部分，抽象到基类中可以简化派生类的实现，避免相同代码的冗余重复。

随着时间的推移，实现继承的缺陷将变得越来越明显，最初被抽象到基类的实现未必能适应新的派生类。维护这样的系统，将成为一件颇具挑战性的工作。

接口继承中的基类不再提供任何实现细节，它中包含一系列“占位符”，告诉派生类它应该提供哪些功能，完全由派生类负责具体细节的实现，即给出成员变量和成员函数的定义。

在接口继承的基础上，发展出依赖注入的概念。类中包含一个指针类型的成员，该指针的类型通常是一个接口，接口决定了通过该指针能够做什么，而具体怎么做则取决于该指针实际引用的对象，该对象的类型是一个接口的实现类。只要为该指针注入不同的实现类对象，即可表现出不同的实现策略。这样的系统更容易维护和进化。

### 10.1.7 借助variant模板和visit函数实现运行时多态

借助C++17的variant类模板和标准库的visit函数，可以在不使用继承和虚函数的前提下，实现运行时多态。

在类型无关的对象上，执行共同的功能，称为鸭式类型。

### 10.1.8 多继承

一个派生类可以继承自多个基类。

多继承的潜在问题，及基于虚继承的解决方案。

### 10.1.9 实现多态的其它方式

除虚函数以外的其它运行时多态技术。

基于模板的编译时多态技术。

新的概念特性，有助于消除一些旧技术的使用必要，并扩充了工具箱，提供基于模板的编译时多态解决方案。

### 10.1.10 理解运行时多态的价值

只有深入理解运行时多态的概念、方法和机制，才能更好地欣赏现代多态惯用法和技术，它们最终促进了修改和维护程序代码的便利性，同时获得更好的性能。