## 15.1 导读

自C++98开始，基于模板的泛型编程就一直是C++语言的重要特性之一，而且随着每个版本的发布，其重要性也在不断得到加强。现代C++的宗旨之一，就是在编译期做更多的事情，以获得更充分的类型检查，和更卓越的运行性能，而模板及模板元编程，恰恰是实现编译期操作的关键。

深入研究模板、自定义类模板、概念和模板元编程。

### 15.1.1 自定义类模板

编译器利用函数模板生成重载函数的过程，称为函数模板的实例化。

编译器利用类模板生成类的过程，称为类模板的实例化。

在编译期完成对类模板的实例化，可被视为一种静态多态的实现机制。

### 15.1.2 模板的新特性

C++20为模板增加了新的特性，如缩写函数模板、模板化lambda表达式、概念等。其中，概念是C++20的四大特性之一。借助概念，基于模板的泛型编程，将变得更加方便，更加强大。一种算法能否用于某种容器，取决于该容器的迭代器能否满足算法的要求。该要求可以通过概念予以表达。

编译器在实例化模板主体之前先检查概念。这通常可以产生更少量、更清晰和更精确的错误信息。

### 15.1.3 类型萃取

类型萃取用于在编译期间，测试内置类型和自定义类型的类型特征。许多概念都是以类型萃取的形式实现的。概念简化了，通过类型萃取，约束模板参数的过程。

### 15.1.4 自定义容器、迭代器和算法

将MyArray类升级为类模板，使其可以存储任意类型的数据元素。为MyArray类模板定义迭代器，使其兼容于大多数标准库算法。自定义一个算法函数，支持包括MyArray在内的多数标准库容器。

### 15.1.5 可变参数模板和折叠表达式

构建一个可变参数函数模板，它可以接受数量可变的参数。

借助C++17的折叠表达式，可对传递给变参模板的所有参数，执行一个操作。

### 15.1.6 模板元编程

C++核心准则将模板元编程定义为，创建在编译期合成代码的程序。编译器在编译期所能做的工作包括：

- 编译期计算：缩短运行时间，减低内存消耗，提升程序的运行性能
- 编译器类型操作：借助萃取，根据模板参数的特性，生成不同代码

C++20的概念使模板元编程变得更加友好，也更易于理解。

C++核心准则指出，应该仅在需要时使用模板元编程，而且它很难做到正确，往往也很难维护。借助C++20的概念及C++23在这方面的改进，模板元编程的难度和复杂度，将大幅下降。