# 附录B ASCII字符集

## B.1 ASCII码表

16进制|0|1|2|3|4|5|6|7|8|9|A|B|C|D|E|F
:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:
__0__|NUL|SOH|STX|ETX|EOT|ENQ|ACK|BEL|BS|HT|LF/NL|VT|FF/NP|CR|SO|SI
__1__|DLE|DC1/XON|DC2|DC3/XOFF|DC4|NAK|SYN|ETB|CAN|EM|SUB|ESC|FS|GS|RS|US
__2__|SP|!|"|#|$|%|&|'|(|)|*|+|,|-|.|/
__3__|0|1|2|3|4|5|6|7|8|9|:|;|<|=|>|?
__4__|@|A|B|C|D|E|F|G|H|I|J|K|L|M|N|O
__5__|P|Q|R|S|T|U|V|W|X|Y|Z|[|\\|]|^|_
__6__|`|a|b|c|d|e|f|g|h|i|j|k|l|m|n|o
__7__|p|q|r|s|t|u|v|w|x|y|z|{|\||}|~|DEL

## B.2 ASCII码表中的控制字符

字符名|ASCII码（16进制）|解释
:-:|:-:|:-
NUL|0|空字符（NULL），早期计算机在纸带上留出八个二进制位的空位置，C语言字符串的结尾标志
SOH|1|头开始（Start Of Heading），数据帧帧头起始字符
STX|2|正文开始（Start Of Text），数据帧正文起始字符
ETX|3|正文结束（End Of Text），数据帧正文终止字符
EOT|4|传输结束（End Of Transmission）
ENQ|5|请求（Enquiry）
ACK|6|应答（Acknowledge）
BEL|7|响铃（Bell）
BS|8|退格（Backspace）
HT|9|水平制表（Horizontal Tab）
LF/NL|A|换行（Line Feed/New Line）
VT|B|垂直制表（Vertical Tab）
FF/NP|C|换页（Form Feed/New Page）
CR|D|回车（Carriage Return）
SO|E|切出（Shift Out），切换到其它非英语字符
SI|F|切入（Shift In），切换回英语字符
DLE|10|数据链路转义（Data Link Escape），后面的字符不代表该字符本身，而代表其它含义
DC1/XON|11|设备控制1/传输开启（Device Control 1/Transmission On），重新开启被关闭的信息传输
DC2|12|设备控制2（Device Control 2）
DC3/XOFF|13|设备控制3/传输关闭（Device Control 3/Transmission Off），关闭信息传输
DC4|14|设备控制4（Device Control 4）
NAK|15|响应异常（Negative Acknowledge）
SYN|16|同步空闲（Synchronous Idle）
ETB|17|传输块终止（End of Transmission Block）
CAN|18|取消（Cancel）
EM|19|介质终点（End of Medium）
SUB|1A|替换（Substitute）
ESC|1B|逃离（Escape）
FS|1C|文件分隔符（File Separator）
GS|1D|组分隔符（Group Separator）
RS|1E|记录分隔符（Record Separator）
US|1F|单元分隔符（Unit Separator）
SP|20|空格（Space）
DEL|7F|删除（Delete）